SuperStrict 

Const GRWidth:Int = 400
Const GRHeight:Int = 300
Const genau:Float = 0.5
Const k:Float = GRHEight*20
Global minimap:Float =0.2

SetGraphicsDriver( GLMax2DDriver() )

AppTitle$ = "Raycasting"
Graphics GRWidth, GRHeight, 0, 60

Global  size:Int = 9
Global Map:Byte[size, size]

Global Image:TPixmap[4]
	Image[0] = LoadPixmapPNG( "rock.png" )
	Image[1] = LoadPixmapPNG( "water.png" )
	Image[2] = LoadPixmapPNG( "grass.png" )
	Image[3] = LoadPixmapPNG( "kachel.png" )
	
Global Buffer:TPixmap = CreatePixmap( GRWidth, GRHeight, PF_RGBA8888 )
	MaskPixmap( Buffer, 0, 0, 0 )

Type TPlayer

	Field XPos:Float
	Field YPos:Float
	Field Angle:Float
	Field View:Float
	
	Method RayCast( )
		ClearPixels( Buffer, $00000000 )
		For Local xx:Int = 0 To GRWidth-1
			Local w:Float = Angle + ( (Float(xx) / Float(GRWidth)) * view - view/2 )
			Local found:Byte = 0, i:Float
			Local M_s:Float = Sin( w )
			Local M_c:Float = Cos( w )
			While Not (found = 1)
				Local x:Float = XPos + M_c * ( i * genau )
				Local y:Float = YPos + M_s * ( i * genau )
				Local mx:Int = Floor( x/20.0 )
				Local my:Int = Floor( y/20.0 )
				If mx < 0 Or my < 0 Or mx >= size Or my >= size Then Exit
				If map[ mx, my ] > 0 Then 
					Local AbsWall:Float = i * genau
					Local h:Float = k / (AbsWall*Cos(w-Angle ))
					Local pix:Int[128]
					Local x_abs:Float = mx*20 + 10 - x
					Local y_abs:Float = my*20 + 10 - y 
					Local x_win:Float = ( ( ATan2( y_abs, x_abs ) + 405 ) Mod 90 )
					Local x_pos:Float = ( x_win / 90.0 ) * 127.0
					For i = 0 To 127
						pix[i] = ReadPixel( Image[ map[mx, my]-1 ], x_pos , i ) 						
					Next		
					h = Min( h, GRHeight )			
					For i = 0 To h
						Local pix_i:Int = Floor( Min( Max( (i/h)*127.0, 0 ), 127.0 ) )
						WritePixel( Buffer, xx, Min( Max( GRHeight/2-h/2+i, 0 ), GRHeight-1 ) , pix[ pix_i ] )
					Next 
					found = 1 
					Exit 
				EndIf 
				i = i + 1
			Wend 
		Next 
	End Method 
	
End Type 


For Local i:Int = 0 To size-1
	Map[ i, 0 ] = 1
	Map[ i, size-1 ] = 1
	Map[ 0, i ] = 1
	Map[ size-1, i ] = 1
Next 
Map[ (size-1)/2, (size-1)/2 ] = 3

Global Player:TPlayer = New TPlayer
	Player.Xpos = 70
	Player.YPos = 110
	Player.Angle = 270
	Player.View = 60
	
LoadLevel("Map.txt")

	
	
Repeat
	If KeyDown( KEY_A ) Then 
		Player.Angle = Player.Angle - 1
		If Player.Angle < 0 Then Player.Angle = 360 - Player.Angle 
	EndIf
	If KeyDown( KEY_D ) Then Player.Angle = ( Player.Angle + 1 ) Mod 360
	If KeyDown( KEY_W ) Then 
		Player.YPos = Player.YPos + Sin( Player.Angle ) * 1
		Player.XPos = Player.XPos + Cos( Player.Angle ) * 1
	EndIf 
	If KeyDown( KEY_S ) Then 
		Player.YPos = Player.YPos - Sin( Player.Angle ) * 1
		Player.XPos = Player.XPos - Cos( Player.Angle ) * 1
	EndIf 
	Local ms:Int = MilliSecs( )
	Player.RayCast( )
	DrawPixmap( Buffer, 0, 0 )
	Local time:Int = MilliSecs( ) - ms
	
	SetBlend(ALPHABLEND)
	SetAlpha( 0.5 )
	SetColor( 255, 255, 255 )
	For Local x:Int = 0 To size-1
		For Local y:Int = 0 To size-1
			If Map[x,y] Then DrawRect ( x*20*minimap, y*20*minimap, 19*minimap, 19*minimap )
		Next 
	Next 
	SetColor( 0, 255, 0 )
	DrawOval( (Player.XPos-3)*minimap, (Player.YPos-3)*minimap, 6*minimap, 6*minimap )
	Local w1:Float = Player.Angle - Player.View / 2
	Local w2:Float = Player.Angle + Player.View / 2
	DrawLine( Player.XPos*minimap, Player.YPos*minimap, (Player.XPos+Cos( w1 )*100)*Minimap, (Player.YPos+Sin( w1 )*100)*minimap )
	DrawLine( Player.XPos*minimap, Player.YPos*minimap, (Player.XPos+Cos( w2 )*100)*minimap, (Player.YPos+Sin( w2 )*100)*minimap )
	SetAlpha( 1 )
	SetBlend( SOLIDBLEND )
	DrawText( "Time : "+Time+"ms", 300, 1 )	
	Flip 0
	'Cls

Until KeyHit( KEY_ESCAPE ) Or AppTerminate( )
End 

Function LoadLevel:Int( name:String )
	Local dat:TStream = ReadFile( name )
	If dat = Null Then Return 0
	Size = Int( ReadLine( dat ) )
	minimap = Float( Min( GRWidth, GRHeight ) ) / Float(Size*20.0)
	Local startx:Int = Int( ReadLine( dat ) )
	Local starty:Int = Int( ReadLine( dat ) )
	Local startw:Int = Float( ReadLine( dat ) )
	map = New Byte[ size, size ]
	Local x:Int, y:Int
	While Not Eof( dat )
		Local l:String = ReadLine( dat )
		x = 0
		For Local i:Int = 1 To Len( l )
			Local Z:Byte = Byte( Mid( l, i, 1 ) )
			map[ x, y ] = Z
			x = x + 1
		Next 
		y = y + 1
	Wend 
	Player.XPos = startx*20+10
	Player.YPos = starty*20+10
	Player.Angle = startw
	CloseFile( dat )
End Function 

Function ClearPixmap( tmpPixmap:TPixmap )
	Rem
	For Local xx:Int = 0 To GRWidth-1
		For Local yy:Int = 0 To GRHeight/2-1
			WritePixel( tmpPixmap, xx, yy, $FF5555DD )
			WritePixel( tmpPixmap, xx, GRHeight/2+yy, $FFCCCCCC )
		Next 
	Next 
	EndRem
	ClearPixels( tmpPixmap )
End Function 
			

